#include "Truck.h"

void init_truck(struct Truck *truck, struct city *city){
    //truck = malloc(sizeof(struct Truck));
    truck->city = city;
    truck->i_terminals = 0;
    truck->n_bike = TRUCK_CAPACITE_TYP;
    truck->nslots = city->nSlots;
    truck->num_thread = city->npersons;
    truck->nbterminals = city->nTerminal;
    truck->nbpersons = city->npersons;
}

int rand_Dc(){
    return (rand()%99)+100;
}

void *trucks(void *arg){
    struct Truck *truck = (struct Truck*)arg;
    int tmp_nbBikes;
    
    while(truck->city->personsFinished < truck->nbpersons){
        //1 : for each terminals from 1 to S (0 is the depot)
        for(int i=1; i<truck->nbterminals; i++){
            //spreads the bikes evenly
            //too many bikes in this terminals
            tmp_nbBikes = truck->n_bike;
            if(truck->city->terminals[i].nb_bikesParked > (truck->nslots-2) && truck->n_bike < TRUCK_CAPACITE_MAX){
                while(truck->city->terminals[i].nb_bikesParked > (truck->nslots-2) && truck->n_bike < TRUCK_CAPACITE_MAX){
                    sem_wait(truck->city->terminals[i].sem_BikeFree);
                    pthread_mutex_lock(truck->city->terminals[i].mutex);
                    truck->n_bike += 1;
                    truck->city->terminals[i].nb_bikesParked -= 1;
                    pthread_mutex_unlock(truck->city->terminals[i].mutex);
                    sem_post(truck->city->terminals[i].sem_FreeSlot);
                }

                pthread_mutex_lock(truck->city->terminals[i].mutex);
                printf("truck removes %d bikes at terminal %d (%d bikes, %d persons waiting, %d left in truck)\n", truck->n_bike-tmp_nbBikes, i, truck->city->terminals[i].nb_bikesParked, truck->city->terminals[i].nb_P_waiting, truck->n_bike);
                pthread_mutex_unlock(truck->city->terminals[i].mutex);
            }
            // not enough bikes in this terminals
            // until he gets at least 2 bikes (or the truck is empty)
            else if(truck->city->terminals[i].nb_bikesParked < CITY_CAPACITY_MIN && truck->n_bike > 0){
                tmp_nbBikes = truck->n_bike;
                while(truck->city->terminals[i].nb_bikesParked < CITY_CAPACITY_MIN && truck->n_bike > 0){
                    sem_wait(truck->city->terminals[i].sem_FreeSlot);
                    pthread_mutex_lock(truck->city->terminals[i].mutex);
                    truck->n_bike -= 1;
                    truck->city->terminals[i].nb_bikesParked += 1;
                    pthread_mutex_unlock(truck->city->terminals[i].mutex);
                    sem_post(truck->city->terminals[i].sem_BikeFree);
                }

                pthread_mutex_lock(truck->city->terminals[i].mutex);
                printf("truck adds %d bikes at terminal %d (%d bikes, %d persons waiting, %d left in truck)\n", tmp_nbBikes-truck->n_bike, i, truck->city->terminals[i].nb_bikesParked, truck->city->terminals[i].nb_P_waiting, truck->n_bike);
                pthread_mutex_unlock(truck->city->terminals[i].mutex);
            }
        }
        //2: goes to the depot to rebalance the truck's content to 2 bycycles
        tmp_nbBikes = truck->n_bike;
        if(truck->n_bike < TRUCK_CAPACITE_TYP){
            if(truck->city->terminals[DEPOT].nb_bikesParked > 0){
                while(truck->n_bike < TRUCK_CAPACITE_TYP && truck->city->terminals[DEPOT].nb_bikesParked > 0){
                    truck->n_bike += 1;
                    pthread_mutex_lock(truck->city->terminals[DEPOT].mutex);
                    truck->city->terminals[DEPOT].nb_bikesParked -= 1;
                    pthread_mutex_unlock(truck->city->terminals[DEPOT].mutex);
                }
                pthread_mutex_lock(truck->city->terminals[DEPOT].mutex);
                printf("(DEPOT) truck gets %d bikes at terminal %d (%d bikes, %d persons waiting, %d left in truck)\n", truck->n_bike-tmp_nbBikes, DEPOT, truck->city->terminals[DEPOT].nb_bikesParked, truck->city->terminals[DEPOT].nb_P_waiting, truck->n_bike);
                pthread_mutex_unlock(truck->city->terminals[DEPOT].mutex);
            }
        }
        else if (truck->n_bike > TRUCK_CAPACITE_TYP){
            while(truck->n_bike > TRUCK_CAPACITE_TYP){
                truck->n_bike -= 1;
                pthread_mutex_lock(truck->city->terminals[DEPOT].mutex);
                truck->city->terminals[DEPOT].nb_bikesParked += 1;
                pthread_mutex_unlock(truck->city->terminals[DEPOT].mutex);
            }
            pthread_mutex_lock(truck->city->terminals[DEPOT].mutex);
            printf("(DEPOT) truck deposit %d bikes at terminal %d (%d bikes, %d persons waiting, %d left in truck)\n", tmp_nbBikes-truck->n_bike, DEPOT, truck->city->terminals[DEPOT].nb_bikesParked, truck->city->terminals[DEPOT].nb_P_waiting, truck->n_bike);
            pthread_mutex_unlock(truck->city->terminals[DEPOT].mutex);
        }
        //3: pause betweem 100us up to 199us
#if USLEEP
        usleep(rand_Dc());
#endif
        //printf("TRUCK new loop, person's threads finished: %d\n", personsFinished);
    }
    printf("TRUCK end loop\n");
    return NULL;
}

//unused
/*void free_truck(struct Truck **truck){
    (*truck)->city = NULL;
    free(*truck);
    truck = NULL;
}*/