#include "city.h"

void init_city(struct city* city, int nbTerminals, int npersons, int nbSlots){
    //city = malloc(sizeof(struct city));
    city->nTerminal = nbTerminals;
    city->npersons = npersons;
    city->nSlots = nbSlots;
    city->personsFinished = 0;

    city->terminals = calloc(city->npersons, sizeof(struct city));

    for(int j = 0; j<city->npersons; j++){
        city->terminals[j].nb_bikesParked = nbSlots-2;
        city->terminals[j].nb_P_waiting = 0;
        city->terminals[j].sem_BikeFree = malloc(sizeof(sem_t));
        city->terminals[j].sem_FreeSlot = malloc(sizeof(sem_t));
        city->terminals[j].mutex = malloc(sizeof(pthread_mutex_t));

        sem_init(city->terminals[j].sem_BikeFree, 0, nbSlots-2);
        sem_init(city->terminals[j].sem_FreeSlot, 0, nbSlots-(nbSlots-2));
        pthread_mutex_init(city->terminals[j].mutex, NULL);
    }
    city->terminals[DEPOT].nb_bikesParked = 0;
    pthread_barrier_init(&city->b, NULL, city->npersons);
}

//unused
void free_city(struct city *city){
        //free the memory
        for(int i=0; i<city->nTerminal; i++){
            sem_destroy(city->terminals[i].sem_BikeFree);
            sem_destroy(city->terminals[i].sem_FreeSlot);
            pthread_mutex_destroy(city->terminals[i].mutex);
        }
        pthread_barrier_destroy(&city->b);
        for(int i=0; i<city->nTerminal; i++){
            free(city->terminals[i].sem_BikeFree);
            free(city->terminals[i].sem_FreeSlot);
            free(city->terminals[i].mutex);
        }
        for(int i= 0; i<city->nTerminal; i++){
            free(&city->terminals[i]);
        }
        free(city);
}