#ifndef _CITY_H_
#define _CITY_H_

#include <stdio.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <semaphore.h>


#define CITY_CAPACITY_MIN 2 //min nb of bikes
#define DEPOT  0        //depot's index

#define USLEEP 1        //activate usleep() = 1 or no = 0

struct terminal{
    int nb_bikesParked; //number of bikes parked in terminal
    int nb_P_waiting;   //number of persons waiting in terminal
    sem_t *sem_FreeSlot;    //semaphore of the free parking slots -> one each terminal
    sem_t *sem_BikeFree;    //semaphore of the free bike -> one each terminal
    pthread_mutex_t *mutex; //mutex -> one for each terminal
};

struct city{
    int npersons;   //nb of persons in the city
    int nSlots;     //nb of slots for each terminal
    int nTerminal;  //nb of terminals in the city
    int personsFinished;    //nb of persons that finished it's iterations
    pthread_barrier_t b;    //barrier to wait for every person before ending the programm
    struct terminal *terminals; //all the terminals in the city
};

void init_city(struct city* city, int nbTerminals, int npersons, int nbSlots);

//unused
void free_city(struct city *city);

#endif