#include "civilian.h"
struct city *city_;

void init_civilians(struct person *civil, struct city *city, int nbTrajets){
    //civil = calloc(city->npersons, sizeof(struct person));
    for(int i=0; i<city->npersons; i++){
        civil[i].max_travels = nbTrajets;
        civil[i].nslots = city->nSlots;
        civil[i].nbTerminals = city->nTerminal;
        civil[i].num_thread = i;
        civil[i].nb_travels = 0;
        civil[i].i_terminals = (rand()%(civil[i].nbTerminals - 1))+1;
    }
    city_ = city;
}

int rand_D(){
    return (rand()%999)+1000;
}

void *Persons(void *arg){
    struct person *pers = (struct person*)arg;
    int j=0;
    int val;
    // inside a Mtravels loop for each persons
    while(pers->nb_travels < pers->max_travels){
        //waits for a bike in terminals i
        //if(pers->i_terminals==4){
        sem_getvalue(city_->terminals[pers->i_terminals].sem_FreeSlot,&val);
        pthread_mutex_lock(city_->terminals[pers->i_terminals].mutex);
        printf("(GET) person %d starts from terminal %d (%d bykes, %d persons waiting, semslotsFree_val : %d)\n", pers->num_thread, pers->i_terminals, city_->terminals[pers->i_terminals].nb_bikesParked, city_->terminals[pers->i_terminals].nb_P_waiting, val);//terminals[pers->i_terminals].nb_P_waiting);
        pthread_mutex_unlock(city_->terminals[pers->i_terminals].mutex);
        //}

        if(city_->terminals[pers->i_terminals].nb_bikesParked<=0){// && pers->i_terminals == 4){
            printf("person %d is STUCK at terminal %d: rack empty : %d bikes\n", pers->num_thread, pers->i_terminals, city_->terminals[pers->i_terminals].nb_bikesParked);
        }

        pthread_mutex_lock(city_->terminals[pers->i_terminals].mutex);
        city_->terminals[pers->i_terminals].nb_P_waiting += 1;
        pthread_mutex_unlock(city_->terminals[pers->i_terminals].mutex);


        sem_wait(city_->terminals[pers->i_terminals].sem_BikeFree);
        pthread_mutex_lock(city_->terminals[pers->i_terminals].mutex);
        city_->terminals[pers->i_terminals].nb_P_waiting -= 1;
        city_->terminals[pers->i_terminals].nb_bikesParked -= 1; //critical section
        pthread_mutex_unlock(city_->terminals[pers->i_terminals].mutex);
        sem_post(city_->terminals[pers->i_terminals].sem_FreeSlot);
        //if(pers->i_terminals==4){
        printf("person %d leaves terminal %d by bike\n", pers->num_thread, pers->i_terminals);
        //}


        //go to place j = rand()%nterminals and j != i
        do{
            j = (rand()%(pers->nbTerminals - 1))+1;
        }while(j==pers->i_terminals);
#if USLEEP
        usleep(rand_D());
#endif

        //waits for a parkinglot to be freed and deposit his bycycle
        //if(j==4){
        sem_getvalue(city_->terminals[j].sem_BikeFree,&val);
        pthread_mutex_lock(city_->terminals[j].mutex);
        printf("(PUT) person %d arrives at terminal %d (%d bykes, %d persons waiting, semBikeFree_val : %d)\n", pers->num_thread, j, city_->terminals[j].nb_bikesParked, city_->terminals[j].nb_P_waiting, val);//terminals[j].nb_P_waiting);
        pthread_mutex_unlock(city_->terminals[j].mutex);
        //}
        

        if(city_->terminals[j].nb_bikesParked>=pers->nslots){//} && j == 4){
            printf("person %d is STUCK at terminal %d: rack full : %d bikes\n", pers->num_thread, j, city_->terminals[j].nb_bikesParked);
        }

        pthread_mutex_lock(city_->terminals[j].mutex);
        city_->terminals[j].nb_P_waiting += 1;
        pthread_mutex_unlock(city_->terminals[j].mutex);


        sem_wait(city_->terminals[j].sem_FreeSlot);
        pthread_mutex_lock(city_->terminals[j].mutex);
        //deposit his bycycle
        city_->terminals[j].nb_P_waiting -= 1;
        city_->terminals[j].nb_bikesParked += 1; //critical section 
        pthread_mutex_unlock(city_->terminals[j].mutex);
        sem_post(city_->terminals[j].sem_BikeFree);
        //if(j==4){
        printf("person %d leaves terminal %d by foot\n", pers->num_thread, j);
        //}

        //does whatever he has to do for a D delay time (waits for rand() 1000->1999us)
#if USLEEP
        usleep(rand_D());
#endif
        //changes his position from terminals i = j (j is the new terminals)
        pers->i_terminals = j;
        pers->nb_travels += 1;
    }
    printf("person %d stops\n", pers->num_thread);
    //pthread_mutex_lock(city_->terminals[pers->i_terminals].mutex);
    city_->personsFinished += 1;
    //pthread_mutex_unlock(city_->terminals[pers->i_terminals].mutex);
    pthread_barrier_wait(&city_->b);

    return NULL;
}

//unused
void free_Person(struct person **pers){
    city_ = NULL;
    free((*pers));
    pers = NULL;
}