#include <stdio.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <semaphore.h>
#include "civilian.h"
#include "Truck.h"
#include "city.h"

int main(int argc, char **argv){
    if (argc < 5 || argc > 5){
        perror("erreur d'arguments d'entrée\n");
        return EXIT_FAILURE;
    }
    int nbterminals = atoi(argv[1]);    //S 10 
    int nbpersons = atoi(argv[2]);      //H 100
    int nbTravels = atoi(argv[3]);      //M 10
    int nbslots = atoi(argv[4]);        //N 10
    nbterminals += 1;
    srand(0);

    pthread_t *threadpersons = malloc(sizeof(pthread_t)*nbpersons);
    pthread_t *threadTruck = malloc(sizeof(pthread_t));

    struct city city;
    struct person *persons = malloc(sizeof(struct person)*nbpersons);
    struct Truck truck;
    init_city(&city, nbterminals, nbpersons, nbslots);
    init_civilians(persons, &city, nbTravels);
    init_truck(&truck, &city);

    if(pthread_create(threadTruck, NULL, trucks, (void*)&truck)!=0){
        perror("thread creation error");
        return EXIT_FAILURE;
    }
    for(int i=0; i<nbpersons; i++){
        if(pthread_create(&threadpersons[i], NULL, Persons, (void*)&persons[i])!=0){
            perror("thread creation error");
            return EXIT_FAILURE;
        }
    }

    if(pthread_join(*threadTruck, NULL)){
        perror("thread join error");
        return EXIT_FAILURE;
    }
    for(int i=0; i<nbpersons; i++){
        if(pthread_join(threadpersons[i], NULL)){
            perror("thread join error");
            return EXIT_FAILURE;
        }
    }


    printf("***************** CYCLING TERMINATED ***************\n");
    int sum=0;
    for(int i=1; i<city.nTerminal; i++){
        printf("Terminal %d contains %d bikes\n", i, city.terminals[i].nb_bikesParked);
        sum+=city.terminals[i].nb_bikesParked;
    }
    printf("total number of bikes in town: %d, in depot: %d, in truck: %d, total: %d\n", sum, city.terminals[DEPOT].nb_bikesParked, truck.n_bike, truck.n_bike+city.terminals[DEPOT].nb_bikesParked+sum);


    //free the memory
    free(threadpersons);
    free(threadTruck);
    free(persons);

    return EXIT_SUCCESS;
}